local MODNAME = 'MusicalEvents'
local ShivvAudio = LibStub('AceAddon-3.0'):GetAddon('ShivvAudio')
local MusicalEvents = ShivvAudio:NewModule(MODNAME, 'AceEvent-3.0')

local me -- local db ref

local function EventRegister(event, reg)
	if (reg) then
		MusicalEvents:RegisterEvent(event)
	else
		MusicalEvents:UnregisterEvent(event)
	end
end

function MusicalEvents:OnInitialize()
	me = ShivvAudio.db.profile.musicalEvents

	self:SetEnabledState(ShivvAudio.db.profile.enableMusicalEvents)
end

function MusicalEvents:OnEnable()
	EventRegister('PLAYER_ACHIEVEMENT', 	(me.achievement ~= 0))
	EventRegister('AUCTION_HOUSE_SHOW', 	(me.auction ~= 0))
	EventRegister('AUCTION_HOUSE_CLOSED', 	(me.auction ~= 0))
	EventRegister('BANKFRAME_OPENED', 		(me.bank ~= 0))
	EventRegister('BANKFRAME_CLOSED', 		(me.bank ~= 0))
	EventRegister('GUILDBANKFRAME_OPENED', 	(me.bank ~= 0))
	EventRegister('GUILDBANKFRAME_CLOSED', 	(me.bank ~= 0))
	EventRegister('TRADE_SKILL_SHOW', 		(me.crafting ~= 0))
	EventRegister('TRADE_SKILL_CLOSE', 		(me.crafting ~= 0))
	EventRegister('PLAYER_DEAD', 			(me.death ~= 0))
	EventRegister('PLAYER_LEVEL_UP', 		(me.levelup ~= 0))
	EventRegister('LOOT_OPENED', 			(me.lootopen ~= 0) or 		(me.looting ~= 0))
	EventRegister('LOOT_CLOSED', 			(me.lootclose ~= 0) or 		(me.looting ~= 0))
	EventRegister('MERCHANT_SHOW', 			(me.shop ~= 0))
	EventRegister('MERCHANT_CLOSED', 		(me.shop ~= 0))
end

function MusicalEvents:OnDisable()
	EventRegister('PLAYER_ACHIEVEMENT', 	false)
	EventRegister('AUCTION_HOUSE_SHOW', 	false)
	EventRegister('AUCTION_HOUSE_CLOSED', 	false)
	EventRegister('BANKFRAME_OPENED', 		false)
	EventRegister('BANKFRAME_CLOSED', 		false)
	EventRegister('GUILDBANKFRAME_OPENED', 	false)
	EventRegister('GUILDBANKFRAME_CLOSED', 	false)
	EventRegister('TRADE_SKILL_SHOW', 		false)
	EventRegister('TRADE_SKILL_CLOSE', 		false)
	EventRegister('PLAYER_DEAD', 			false)
	EventRegister('PLAYER_LEVEL_UP', 		false)
	EventRegister('LOOT_OPENED', 			false)
	EventRegister('LOOT_CLOSED', 			false)
	EventRegister('MERCHANT_SHOW', 			false)
	EventRegister('MERCHANT_CLOSED', 		false)
end

function MusicalEvents:PLAYER_ACHIEVEMENT()
	ShivvAudio:SoundHandler(me.achievement)
end

function MusicalEvents:AUCTION_HOUSE_SHOW()
	ShivvAudio:MusicHandler('shivvInternalAuction', true)
end

function MusicalEvents:AUCTION_HOUSE_CLOSED()
	ShivvAudio:MusicHandler('shivvInternalAuction', false)
end

function MusicalEvents:BANKFRAME_OPENED()
	ShivvAudio:MusicHandler('shivvInternalBank', true)
end

function MusicalEvents:BANKFRAME_CLOSED()
	ShivvAudio:MusicHandler('shivvInternalBank', false)
end

function MusicalEvents:GUILDBANKFRAME_OPENED()
	ShivvAudio:MusicHandler('shivvInternalBank', true)
end

function MusicalEvents:GUILDBANKFRAME_CLOSED()
	ShivvAudio:MusicHandler('shivvInternalBank', false)
end

function MusicalEvents:TRADE_SKILL_SHOW()
	ShivvAudio:MusicHandler('shivvInternalCrafting', true)
end

function MusicalEvents:TRADE_SKILL_CLOSE()
	ShivvAudio:MusicHandler('shivvInternalCrafting', false)
end

function MusicalEvents:PLAYER_DEAD()
	ShivvAudio:SoundHandler(me.death)
end

function MusicalEvents:PLAYER_LEVEL_UP()
	ShivvAudio:SoundHandler(me.levelup)
end

function MusicalEvents:LOOT_OPENED()
	ShivvAudio:SoundHandler(me.lootopen)
	ShivvAudio:MusicHandler('shivvInternalLooting', true)
end

function MusicalEvents:LOOT_CLOSED()
	ShivvAudio:SoundHandler(me.lootclose)
	ShivvAudio:MusicHandler('shivvInternalLooting', false)
end

function MusicalEvents:MERCHANT_SHOW()
	ShivvAudio:MusicHandler('shivvInternalShop', true)
end

function MusicalEvents:MERCHANT_CLOSED()
	ShivvAudio:MusicHandler('shivvInternalShop', false)
end
