local MODNAME = 'SymphoniousCombatData'
local ShivvAudio = LibStub('AceAddon-3.0'):GetAddon('ShivvAudio')
local SymphoniousCombatData = ShivvAudio:NewModule(MODNAME)
local L = LibStub('AceLocale-3.0'):GetLocale('ShivvAudio')

local data ={
	[465] = { -- hellfire dungeons
		-- ramparts
		[17306] = true,
		[17308] = true,
		[17536] = true,
		[17537] = true,
		-- furnace
		[17381] = true,
		[17380] = true,
		[17377] = true,
		-- shattered halls
		[16807] = true,
		[20923] = true,
		[16809] = true,
		[16808] = true,
		-- magtheridon
		[17257] = true,
	},
	[467] = { -- coilfang dungeons
		-- slave pens
		[17941] = true,
		[17991] = true,
		[17942] = true,
		-- underbog
		[17770] = true,
		[18105] = true,
		[17826] = true,
		[17882] = true,
		-- steamvault
		[17797] = true,
		[17796] = true,
		[17798] = true,
		-- serpentshrine
		[21216] = true,
		[21217] = true,
		[21215] = true,
		[21214] = true,
		[21213] = true,
		[21212] = true,
	},
	[478] = { -- auchindoun
		-- mana tombs
		[18341] = true,
		[18343] = true,
		[18344] = true,
		[22930] = true,
		-- crypts
		[18371] = true,
		[18873] = true,
		-- sethekk
		[18472] = true,
		[18473] = true,
		[23035] = true,
		-- shadow labs
		[18731] = true,
		[18667] = true,
		[18732] = true,
		[18708] = true,
	},
	[499] = { -- sunwell
		[24850] = true,
		[24892] = true,
		[24882] = true,
		[25038] = true,
		[25166] = true,
		[25165] = true,
		[25741] = true,
		[25840] = true,
		[25315] = true,
	},
	[520] = { -- nexus
		[26731] = true,
		[26763] = true,
		[26794] = true,
		[26723] = true,
		[26796] = true,
		[26798] = true,
	},
	[521] = { -- cot strath
		[26529] = true,
		[26530] = true,
		[26532] = true,
		[26533] = true,
		[32273] = true,
	},
	[522] = { -- ahnkahet
		[29309] = true,
		[29308] = true,
		[29310] = true,
		[29311] = true,
		[30258] = true,
	},
	[523] = { -- utgarde keep
		[23953] = true,
		[24200] = true,
		[24201] = true,
		[23954] = true,
	},
	[524] = { -- utgarde pinnacle
		[26668] = true,
		[26687] = true,
		[26693] = true,
		[26861] = true,
	},
	[525] = { -- halls of lightning
		[28586] = true,
		[28587] = true,
		[28546] = true,
		[28923] = true,
	},
	[526] = { -- ulduar
		[33113] = true,
		[33118] = true,
		[33186] = true,
		[33293] = true,
		[32857] = true,
		[32930] = true,
		[33515] = true,
		[32906] = true,
		[32845] = true,
		[33350] = true,
		[32865] = true,
		[33271] = true,
		[33288] = true,
		[32871] = true,
		[27975] = true,
		[27977] = true,
		[27978] = true,
	},
	[527] = { -- eye of eternity
		[28859] = true,
	},
	[528] = { -- oculus
		[27654] = true,
		[27447] = true,
		[27655] = true,
		[27656] = true,
	},
	[529] = { -- ulduar (again?)
		[33113] = true,
		[33118] = true,
		[33186] = true,
		[33293] = true,
		[32857] = true,
		[32930] = true,
		[33515] = true,
		[32906] = true,
		[32845] = true,
		[33350] = true,
		[32865] = true,
		[33271] = true,
		[33288] = true,
		[32871] = true,
		[27975] = true,
		[27977] = true,
		[27978] = true,
	},
	[531] = { -- obsidian sanctum
		[30452] = true,
		[30451] = true,
		[30449] = true,
		[28860] = true,
	},
	[532] = { -- vault of archavon
		[31125] = true,
		[33993] = true,
		[35013] = true,
		[38433] = true,
	},
	[533] = { -- azjol nerub
		[28684] = true,
		[28921] = true,
		[29120] = true,
	},
	[534] = { -- draktharon keep
		[26630] = true,
		[26631] = true,
		[27483] = true,
		[26632] = true,
	},
	[535] = { -- naxx
		[15956] = true,
		[15953] = true,
		[15952] = true,
		[15954] = true,
		[15936] = true,
		[16011] = true,
		[16061] = true,
		[16060] = true,
		[16064] = true,
		[16065] = true,
		[30549] = true,
		[16063] = true,
		[16028] = true,
		[15931] = true,
		[15932] = true,
		[15928] = true,
		[15989] = true,
		[15990] = true,
	},
	[536] = { -- violet hold
		[29315] = true,
		[29316] = true,
		[29313] = true,
		[29266] = true,
		[29312] = true,
		[29314] = true,
		[31134] = true,
	},
	[609] = { -- ruby sanctum
		[39751] = true,
		[39746] = true,
		[39747] = true,
		[39863] = true,
	},
	[680] = { -- ragefire
		[11520] = true,
		[11517] = true,
		[11518] = true,
		[11519] = true,
	},
	[686] = { -- zul farrak
		[8127] = true,
		[7272] = true,
		[7271] = true,
		[7796] = true,
		[7795] = true,
		[7273] = true,
		[7275] = true,
		[7797] = true,
		[7267] = true,
	},
	[687] = { -- sunken temple
		[5710] = true,
		[8443] = true,
		[5709] = true,
	},
	[688] = { -- blackfathom
		[4887] = true,
		[4831] = true,
		[6243] = true,
		[12902] = true,
		[12876] = true,
		[4832] = true,
		[4830] = true,
		[4829] = true,
	},
	[690] = { -- stockade
		[46383] = true,
		[46264] = true,
		[46254] = true,
	},
	[691] = { -- gnomeregan
		[6231] = true,
		[7079] = true,
		[7361] = true,
		[6235] = true,
		[6229] = true,
		[7800] = true,
	},
	[692] = { -- uldaman
		[6910] = true,
		[6906] = true,
		[7228] = true,
		[7023] = true,
		[7206] = true,
		[7291] = true,
		[4854] = true,
		[2748] = true,
	},
	[696] = { -- molten core
		[12118] = true,
		[11982] = true,
		[12259] = true,
		[12057] = true,
		[12264] = true,
		[12056] = true,
		[11988] = true,
		[12098] = true,
		[12018] = true,
		[11502] = true,
	},
	[699] = { -- diremaul
		[11490] = true,
		[13280] = true,
		[14327] = true,
		[11492] = true,
		[14326] = true,
		[14322] = true,
		[14321] = true,
		[14323] = true,
		[14325] = true,
		[11501] = true,
		[14324] = true,
		[11489] = true,
		[11488] = true,
		[11487] = true,
		[11496] = true,
		[11486] = true,
	},
	[704] = { --  depths
		[9025] = true,
		[9027] = true,
		[9016] = true,
		[9319] = true,
		[9018] = true,
		[10096] = true,
		[9024] = true,
		[9033] = true,
		[8983] = true,
		[9543] = true,
		[9537] = true,
		[9499] = true,
		[9502] = true,
		[9017] = true,
		[9056] = true,
		[9041] = true,
		[9042] = true,
		[9438] = true,
		[9442] = true,
		[9443] = true,
		[9439] = true,
		[9437] = true,
		[9441] = true,
		[9156] = true,
		[9034] = true,
		[9035] = true,
		[9036] = true,
		[9037] = true,
		[9038] = true,
		[9039] = true,
		[9040] = true,
		[9938] = true,
		[8929] = true,
		[9019] = true,
	},
	[721] = { -- blackrock spire
		[9196] = true,
		[9236] = true,
		[9237] = true,
		[10596] = true,
		[10584] = true,
		[9736] = true,
		[10268] = true,
		[10220] = true,
		[9568] = true,
		[9816] = true,
		[10429] = true,
		[10339] = true,
		[10430] = true,
		[10363] = true,
	},
	[747] = { -- lost city of the tolvir
		[44577] = true,
		[43612] = true,
		[43614] = true,
		[49045] = true,
		[44819] = true,
	},
	[749] = { -- wailing caverns
		[3671] = true,
		[3669] = true,
		[3653] = true,
		[3670] = true,
		[3674] = true,
		[3673] = true,
		[5775] = true,
		[3654] = true,
	},
	[750] = { -- maraudon
		[13282] = true,
		[12258] = true,
		[12236] = true,
		[12225] = true,
		[12203] = true,
		[13601] = true,
		[13596] = true,
		[12201] = true,
	},
	[752] = { -- bardin hold
		[47120] = true
	},
	[753] = { -- blackrock caverns
		[39665] = true,
		[39679] = true,
		[39698] = true,
		[39700] = true,
		[39705] = true,
	},
	[754] = { -- blackwing descent
		[41570] = true,
		[42180] = true,
		[41378] = true,
		[41442] = true,
		[43296] = true,
		[41376] = true,
	},
	[755] = { -- blackwing lair
		[12435] = true,
		[13020] = true,
		[12017] = true,
		[11983] = true,
		[14601] = true,
		[11981] = true,
		[14020] = true,
		[11583] = true,
	},
	[756] = { -- deadmines
		[47162] = true,
		[47296] = true,
		[43778] = true,
		[47626] = true,
		[47739] = true,
		[49541] = true,
	},
	[757] = { -- grim batol
		[39625] = true,
		[40177] = true,
		[40319] = true,
		[40484] = true,
	},
	[758] = { -- bastion of twilight
		[45992] = true,
		[45993] = true,
		[44600] = true,
		[43735] = true,
		[43324] = true,
	},
	[759] = { -- halls of origination
		[39425] = true,
		[39428] = true,
		[39788] = true,
		[39587] = true,
		[39731] = true,
		[39732] = true,
		[39378] = true,
	},
	[760] = { -- razorfen downs
		[7355] = true,
		[7357] = true,
		[8567] = true,
		[7358] = true,
	},
	[761] = { -- razorfen kraul
		[6168] = true,
		[4424] = true,
		[4428] = true,
		[4420] = true,
		[4422] = true,
		[4421] = true,
	},
	[762] = { -- scarlet monestary
		[3983] = true,
		[4543] = true,
		[3974] = true,
		[6487] = true,
		[3975] = true,
		[4542] = true,
		[3977] = true,
		[3976] = true,
	},
	[763] = { -- scholomance
		[10506] = true,
		[10503] = true,
		[11622] = true,
		[10433] = true,
		[10432] = true,
		[10508] = true,
		[10505] = true,
		[11261] = true,
		[10901] = true,
		[10507] = true,
		[10504] = true,
		[10502] = true,
		[1853] = true,
	},
	[764] = { -- shadowfang keep
		[46962] = true,
		[3887] = true,
		[4278] = true,
		[46963] = true,
		[46964] = true,
	},
	[765] = { -- strathholme
		[10516] = true,
		[10558] = true,
		[10808] = true,
		[11032] = true,
		[10997] = true,
		[10811] = true,
		[10812] = true,
		[10813] = true,
		[10436] = true,
		[10437] = true,
		[10438] = true,
		[10435] = true,
		[10439] = true,
		[45412] = true,
	},
	[766] = { -- ahnqiraj (which one?)
		-- 20 man
		[15348] = true,
		[15341] = true,
		[15340] = true,
		[15370] = true,
		[15369] = true,
		[15339] = true,
		-- 40 man
		[15263] = true,
		[15516] = true,
		[15510] = true,
		[15509] = true,
		[15276] = true,
		[15275] = true,
		[15727] = true,
		[15543] = true,
		[15544] = true,
		[15511] = true,
		[15299] = true,
		[15517] = true,
	},
	[767] = { -- throne of the tides
		[40586] = true,
		[40765] = true,
		[40825] = true,
		[40788] = true,
		[42172] = true,
	},
	[768] = { -- the stonecore
		[43438] = true,
		[43214] = true,
		[42188] = true,
		[42333] = true,
	},
	[769] = { -- vortex pinnacle
		[43878] = true,
		[43873] = true,
		[43875] = true,
	},
	[773] = { -- throne of the four winds
		[45871] = true,
		[46753] = true,
	},
	[1] = {} -- empty zone data for when there is no current entry
}

function SymphoniousCombatData:OnInitialize()
	self:SetEnabledState(ShivvAudio.db.profile.enableSymphoniousCombat) -- activate if sym. combat is active
end

function SymphoniousCombatData:OnEnable()
	-- nothing to do
end

function SymphoniousCombatData:OnDisable()
	-- nothing to do
end

do
	local inI, iType

	function SymphoniousCombatData:GetZoneData(id)
		if (data[id]) then
			return data[id]
		else
			inI, iType = IsInInstance()

			if (inI and iType == 'party' or iType == 'raid') then
				-- missing entry
				ShivvAudio:Print('No boss data for this instance! If you wish this to be fixed, please post a ticket on Curse with the name of the instance and this number: ' .. GetCurrentMapAreaID())
			end

			return data[1]
		end
	end
end

-- -1 arcatraz?? wtf